﻿using System;
using System.Drawing;
using System.Windows.Forms;

using HCW_Class;

namespace HCW_Modify.Forms
{
	public partial class Blank_Form:Form
	{
		MDIMain mdiMain;
		public Blank_Form ()
		{
			InitializeComponent ();
			this.Font = SystemFonts.MessageBoxFont;
		}
		private void Blank_Form_Load (object sender, EventArgs e)
		{
			mdiMain = (MDIMain) this.MdiParent;
		}
		private void Blank_Form_Click (object sender, EventArgs e)
		{
			if (mdiMain.modified_form != sender)
				return;
			Bitmap image = (Bitmap) this.BackgroundImage;

			mdiMain.current_x = ((MouseEventArgs) e).X;
			mdiMain.current_y = ((MouseEventArgs) e).Y;

			if (image.Width < mdiMain.current_x)
				return;
			if (image.Height < mdiMain.current_y)
				return;

			if (mdiMain.gradient_flag)
			{
				mdiMain.Gradient ();
				return;
			}

			HCW hcw = new HCW (image.GetPixel (mdiMain.current_x, mdiMain.current_y));
			
			if (mdiMain.text_flag)
			{
				mdiMain.current_color = mdiMain.ColorPicker ("Text Color", hcw);
				mdiMain.TextPrint ();
				return;
			}

			mdiMain.current_color = mdiMain.ColorPicker ("Current", hcw);
		}
		private void Blank_Form_Closing (object sender, EventArgs e)
		{
			if (mdiMain.original_form == sender)
				mdiMain.CloseForms ();
			if (mdiMain.modified_form == sender)
				mdiMain.CloseForms ();
		}
	}
}
