﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HCW_Class;

namespace HCW_Modify.Forms
{
	public partial class Gradient:Form
	{
		// Properties
		MDIMain mdiMain;

		/// <summary>
		/// Parent is the parent form
		/// </summary>
		public MDIMain theParent
		{
			set
			{
				mdiMain = value;
			}
		}

		public Gradient ()
		{
			InitializeComponent ();
			this.Font = SystemFonts.MessageBoxFont;
		}

		private void Gradient_Load (object sender, EventArgs e)
		{
			UpdateSelectionFields ();
		}

		private void PerformGradientButton_Click (object sender, EventArgs e)
		{
			Close ();
		}

		// Modify Current Color
		private void CurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.current_color = mdiMain.ColorPicker ("Current", mdiMain.current_color);
			UpdateSelectionFields ();
		}

		// Modify Upper Left Color
		private void UpperLeftButton_Click (object sender, EventArgs e)
		{
			mdiMain.sLower_color = mdiMain.ColorPicker ("Upper Left", mdiMain.sLower_color);
			UpdateSelectionFields ();
		}

		// Modify Upper Right Color
		private void UpperRightButton_Click (object sender, EventArgs e)
		{
			mdiMain.sUpper_color = mdiMain.ColorPicker ("Upper Right", mdiMain.sUpper_color);
			UpdateSelectionFields ();
		}

		// Modify Lower Left Color
		private void LowerLeftButton_Click (object sender, EventArgs e)
		{
			mdiMain.tLower_color = mdiMain.ColorPicker ("Lower Left", mdiMain.tLower_color);
			UpdateSelectionFields ();
		}

		// Modify Lower Right Color
		private void LowerRightButton_Click (object sender, EventArgs e)
		{
			mdiMain.tUpper_color = mdiMain.ColorPicker ("Lower Right", mdiMain.tUpper_color);
			UpdateSelectionFields ();
		}

		// Set Upper Left Color to current color
		private void UpperLeftCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.sLower_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		// Set Upper Right Color to current color
		private void UpperRightCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.sUpper_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		// Set Lower Left Color to current color
		private void LowerLeftCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.tLower_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		// Set Lower Right Color to current color
		private void LowerRightCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.tUpper_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		// Set Upper Left Color to a reasonable default color
		private void UpperLeftDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.sLower_color.iHCW (mdiMain.current_color.Hue, 0, 0);
			UpdateSelectionFields ();
		}

		// Set Upper Right Color to a reasonable default color
		private void UpperRightDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.sUpper_color.iHCW (mdiMain.current_color.Hue, 255, 0);
			UpdateSelectionFields ();
		}

		// Set Lower Left Color to a reasonable default color
		private void LowerLeftDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.tLower_color.iHCW (mdiMain.current_color.Hue, 255, 0);
			UpdateSelectionFields ();
		}

		// Set Lower Right Color to a reasonable default color
		private void LowerRightDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.tUpper_color.iHCW (0, 255, 255);
			UpdateSelectionFields ();
		}

		private void UpdateSelectionFields ()
		{

			CurrentLabel.Text = mdiMain.current_color.ToString ();
			CurrentButton.Image = mdiMain.current_color.ToImage ();

			UpperRightLabel.Text = mdiMain.sUpper_color.ToString ();
			UpperRightButton.Image = mdiMain.sUpper_color.ToImage ();

			UpperLeftLabel.Text = mdiMain.sLower_color.ToString ();
			UpperLeftButton.Image = mdiMain.sLower_color.ToImage ();

			LowerRightLabel.Text = mdiMain.tUpper_color.ToString ();
			LowerRightButton.Image = mdiMain.tUpper_color.ToImage ();

			LowerLeftLabel.Text = mdiMain.tLower_color.ToString ();
			LowerLeftButton.Image = mdiMain.tLower_color.ToImage ();
		}
	}
}
