﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HCW_Modify
{
	public partial class RotateText:Form
	{
		MDIMain mdiMain;
		Font save_font;

		public RotateText ()
		{
			InitializeComponent ();
			this.Font = SystemFonts.MessageBoxFont;
		}

		private void RotateText_Load (object sender, EventArgs e)
		{
			mdiMain = (MDIMain) this.Owner;
			textString.Text = "Enter your text";
			numericAngle.Value = 0;
			numericX.Value = mdiMain.current_x;
			numericY.Value = mdiMain.current_y;
			Setfont (textFont.Font);
		}

		private void buttonOK_Click (object sender, EventArgs e)
		{
			Graphics g = Graphics.FromImage (mdiMain.current_image.Bitmap);
			Print (g);
			mdiMain.UpdateImage ();
			Close ();
		}

		private void buttonPrint_Click (object sender, EventArgs e)
		{
			Graphics g = mdiMain.modified_form.CreateGraphics ();
			// erase any previous test data
			g.Clear (mdiMain.modified_form.BackColor);
			g.DrawImage (mdiMain.current_image.Bitmap, 0, 0);
			Print (g);
		}

		private void Print (Graphics g)
		{
			g.RotateTransform ((float) numericAngle.Value);
			g.TextRenderingHint = TextRenderingHint.AntiAliasGridFit;
			g.DrawString (textString.Text, save_font, new SolidBrush (mdiMain.current_color.RGB ()),
				(float) numericX.Value, (float) numericY.Value);
			g.ResetTransform ();
		}

		private void buttonFont_Click (object sender, EventArgs e)
		{
			FontDialog f = new FontDialog ();
			f.Font = save_font;
			if (DialogResult.Cancel == f.ShowDialog ())
				return;
			Setfont (f.Font);
		}

		private void Setfont (Font f)
		{
			save_font = f;
			textFont.Text = f.Name + ", " + f.Size;
		}

	}
}
