﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HCW_Class;

namespace HCW_Modify.Forms
{
	public partial class Transform:Form
	{
		MDIMain mdiMain;

		public Transform ()
		{
			InitializeComponent ();
			this.Font = SystemFonts.MessageBoxFont;
		}

		private void Transform_Load (object sender, EventArgs e)
		{
			mdiMain = (MDIMain) this.Owner;
			UpdateSelectionFields ();
		}

		private void PerformTransformButton_Click (object sender, EventArgs e)
		{
			int x, y;
			int sL_h, sU_h, sR_h, tL_h, tU_h, tR_h;
			int sL_c, sU_c, sR_c, tL_c, tU_c, tR_c;
			int sL_w, sU_w, sR_w, tL_w, tU_w, tR_w;
			HCW hcw = new HCW ();

			mdiMain.ChangeImage ("HCW Transform");

			sL_h = mdiMain.sLower_color.Hue;
			sU_h = mdiMain.sUpper_color.Hue;
			// fix circular region
			if (sU_h < sL_h)
				sR_h = 3601 + sU_h - sL_h;
			else
				sR_h = 1 + sU_h - sL_h;

			tL_h = mdiMain.tLower_color.Hue;
			tU_h = mdiMain.tUpper_color.Hue;
			// fix circular region
			if (tU_h < tL_h)
				tR_h = 3601 + tU_h - tL_h;
			else
				tR_h = 1 + tU_h - tL_h;

			sL_c = mdiMain.sLower_color.Chroma;
			sU_c = mdiMain.sUpper_color.Chroma;
			// fix errors in upper vs lower
			if (sU_c < sL_c)
			{
				x = sU_c;
				sU_c = sL_c;
				sL_c = x;
			}
			sR_c = 1 + sU_c - sL_c;

			tL_c = mdiMain.tLower_color.Chroma;
			tU_c = mdiMain.tUpper_color.Chroma;
			// fix errors in upper vs lower
			if (tU_c < tL_c)
			{
				x = tU_c;
				tU_c = tL_c;
				tL_c = x;
			}
			tR_c = 1 + tU_c - tL_c;

			sL_w = mdiMain.sLower_color.White;
			sU_w = mdiMain.sUpper_color.White;
			// fix errors in upper vs lower
			if (sU_w < sL_w)
			{
				x = sU_w;
				sU_w = sL_w;
				sL_w = x;
			}
			sR_w = 1 + sU_w - sL_w;

			tL_w = mdiMain.tLower_color.W;
			tU_w = mdiMain.tUpper_color.W;
			// fix errors in upper vs lower
			if (tU_w < tL_w)
			{
				x = tU_w;
				tU_w = tL_w;
				tL_w = x;
			}
			tR_w = 1 + tU_w - tL_w;

			// Loop through the images pixels to transform
			for (x = 0; x < mdiMain.current_image.Width; x++)
			{
				for (y = 0; y < mdiMain.current_image.Height; y++)
				{
					hcw.RGB (mdiMain.current_image.GetPixel(x, y));

					if (hcw.White < sL_w)
						continue;
					if (hcw.White > sU_w)
						continue;
					if (hcw.Chroma < sL_c)
						continue;
					if (hcw.Chroma > sU_c)
						continue;
					// wraparound source hue region selection
					if (sU_h < sL_h)
					{
						if (hcw.Hue > sU_h && hcw.Hue < sL_h)
							continue;
					}
					else
					{
						if (hcw.Hue < sL_h)
							continue;
						if (hcw.Hue > sU_h)
							continue;
					}
					int pChroma = hcw.Chroma;
					int pWhite = hcw.White;

					if (mdiMain.transform_White)
						hcw.TWhite = (hcw.White - sL_w) * tR_w / sR_w + tL_w;
					else
						hcw.TChroma = (hcw.Chroma - sL_c) * tR_c / sR_c + tL_c;

				//		MessageBox.Show (
				//		"pChroma " + pChroma + " >> hcw.Chroma " + hcw.Chroma + " pWhite " + pWhite + " >> hcw.White " + hcw.White,
				//		"Chroma scale " + sL_c + ":" + sU_c + " >> " + tL_c + ":" + tU_c + 
				//		" White scale " + sL_w + ":" + sU_w + " >> " + tL_w + ":" + tU_w);

					hcw.Hue = (hcw.Hue - sL_h + 3600) * tR_h / sR_h + tL_h;
					mdiMain.pixels_changed++;
					mdiMain.current_image.SetPixel(x, y, hcw.RGB ());
				}
			}
			mdiMain.UpdateImage ();
			this.Close ();
		}

		private void CurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.current_color = mdiMain.ColorPicker ("Current", mdiMain.current_color);
			UpdateSelectionFields ();
		}

		private void SelectLowerButton_Click (object sender, EventArgs e)
		{
			mdiMain.sLower_color = mdiMain.ColorPicker ("Select Lower", mdiMain.sLower_color);
			UpdateSelectionFields ();
		}

		private void SelectUpperButton_Click (object sender, EventArgs e)
		{
			mdiMain.sUpper_color = mdiMain.ColorPicker ("Select Upper", mdiMain.sUpper_color);
			UpdateSelectionFields ();
		}

		private void TargetLowerButton_Click (object sender, EventArgs e)
		{
			mdiMain.transform_flag = true;
			mdiMain.tLower_color = mdiMain.ColorPicker ("Target Lower", mdiMain.tLower_color);
			mdiMain.transform_flag = false;
			UpdateSelectionFields ();
		}

		private void TargetUpperButton_Click (object sender, EventArgs e)
		{
			mdiMain.transform_flag = true;
			mdiMain.tUpper_color = mdiMain.ColorPicker ("Target Upper", mdiMain.tUpper_color);
			mdiMain.transform_flag = false;
			UpdateSelectionFields ();
		}

		private void SelectLowerCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.sLower_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		private void SelectUpperCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.sUpper_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		private void TargetLowerCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.tLower_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		private void TargetUpperCurrentButton_Click (object sender, EventArgs e)
		{
			mdiMain.tUpper_color.iHCW (mdiMain.current_color);
			UpdateSelectionFields ();
		}

		private void SelectLowerDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.sLower_color.iHCW (0, 1, 0);
			UpdateSelectionFields ();
		}

		private void SelectUpperDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.sUpper_color.iHCW (3599, 255, 254);
			UpdateSelectionFields ();
		}

		private void TargetLowerDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.tLower_color.iHCW (0, 1, 0);
			UpdateSelectionFields ();
		}

		private void TargetUpperDefaultButton_Click (object sender, EventArgs e)
		{
			mdiMain.tUpper_color.iHCW (3599, 255, 254);
			UpdateSelectionFields ();
		}

		private void UpdateSelectionFields ()
		{

			if (mdiMain.transform_White)
			{
				mdiMain.tLower_color.C = 255;
				mdiMain.tUpper_color.C = 255;
			}
			else
			{
				mdiMain.tLower_color.W = 0;
				mdiMain.tUpper_color.W = 0;
			}
			
			CurrentLabel.Text = mdiMain.current_color.ToString ();
			CurrentButton.Image = mdiMain.current_color.ToImage ();

			SelectUpperLabel.Text = mdiMain.sUpper_color.ToString ();
			SelectUpperButton.Image = mdiMain.sUpper_color.ToImage ();

			SelectLowerLabel.Text = mdiMain.sLower_color.ToString ();
			SelectLowerButton.Image = mdiMain.sLower_color.ToImage ();

			TargetUpperLabel.Text = mdiMain.tUpper_color.ToString ();
			TargetUpperButton.Image = mdiMain.tUpper_color.ToImage ();

			TargetLowerLabel.Text = mdiMain.tLower_color.ToString ();
			TargetLowerButton.Image = mdiMain.tLower_color.ToImage ();
		}

		private void radioButtonC_CheckedChanged (object sender, EventArgs e)
		{
		//	this.radioButtonW.Checked = false;
		//	this.radioButtonC.Checked = true;
			mdiMain.transform_White = false;
			UpdateSelectionFields ();
		}

		private void radioButtonW_CheckedChanged (object sender, EventArgs e)
		{
		//	this.radioButtonW.Checked = true;
			this.radioButtonC.Checked = false;
			mdiMain.transform_White = true;
			UpdateSelectionFields ();
		}
	}
}
